#include <avr/io.h>
#include <avr/interrupt.h>

#include <util/delay.h>

#include <stdlib.h>
#include <stdio.h>

void motorLeftBackward(int p) {
	/* Pornesc motorul pentru "p" ms,
	dupa care il opresc pentru "20-p ms.*/
	PORTB |= (1 << PB0);
	PORTB &= ~(1 << PB0);
	_delay_ms(20-p);
}

void motorLeftForward(int p) {
	PORTB |= (1 << PB1);
	_delay_ms(p);
	PORTB &= ~(1 << PB1);
	_delay_ms(20-p);
}

void motorRightBackward(int p) {
	PORTB |= (1 << PB2);
	_delay_ms(p);
	PORTB &= ~(1 << PB2);
	_delay_ms(20-p);
}

void motorRightForward(int p) {
	PORTB |= (1 << PB3);
	_delay_ms(p);
	PORTB &= ~(1 << PB3);
	_delay_ms(20-p);
}

int k = 7;
int factor[8] = {-3*k, -2*k, -1*k, -0, 0, 1*k, 2*k, 3*k};

int main(void)
{	
	int err = 0,i;

	/* Setez pinii PB0-3 ca pini de output pentru motoare*/
	DDRB |= (1 << PB0);
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB3);
	
	/* Setez pinii PA0-7 ca pini de input de la senzori*/
	DDRA &= ~(1 << PA0);
	DDRA &= ~(1 << PA1);
	DDRA &= ~(1 << PA2);
	DDRA &= ~(1 << PA3);
	DDRA &= ~(1 << PA4);
	DDRA &= ~(1 << PA5);
	DDRA &= ~(1 << PA6);
	DDRA &= ~(1 << PA7);
	
	/* Activez rezistentele de pull-up*/
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
    while(1)
    {	
		/* Daca toti senzorii citesc "negru", robotul va merge inainte*/
		if (PINA == 255) {
			motorRightForward(7);
			motorLeftForward(7);
			continue;
		}
		/* Daca robotul a pierdut linia  (toti senzorii citesc "alb",
		atunci robotul va merge in directia senzorului ce a vazut ultima
		data linia. Mototorul din "interiorul" curbei va merge cu spatele
		pentru o mai rapida regasire a liniei */
		if (PINA == 0) {
			if(err>0) {
				motorLeftForward(12);
				motorRightBackward(7);
			} else{
				motorRightForward(12);
				motorLeftBackward(7);
			}
			continue;
		}
		
		/* Daca nu e vreunul dintre cazurile limita de mai sus, programul va
		citi senzorii si va calcula eroarea */
		err = 0;
		for (i = 0; i < 8; i++) {
			if (PINA & (1 << i)) {
				err += factor[i];
			}
		}
		
		/* Folosind eroarea stim ce viteza sa dam pe fiecare motor */
		motorRightForward(7 - err);
		motorLeftForward(7 + err);
		
    }

    return 0;
}
